--heder do z056
--#autor: Asd4
--$data: 03/11/2011r.
heder_bs = {};

function heder_bs.prerequisitesPresent(specializations)
    return true;
end;

function heder_bs:load(xmlFile)

self.animacjapasy = {};
       	     local i = 0;
       		while true do
            	local key = string.format("vehicle.animacjapasy.animacjapasow(%d)", i);

          if not hasXMLProperty(xmlFile, key) then
               break;
           end;

         	local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
            	local speed = Utils.getVectorNFromString(getXMLString(xmlFile, key.."#speed"), 2);
          	if node ~= nil and speed then
                table.insert(self.animacjapasy, {node=node, speed=speed});
           end;
	i = i +1;
      end;

	

self.threshingParticleSystems = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.threshingParticleSystems.threshingParticleSystem(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		if nodei == nil then
			break;
		end;
		local isStatic = Utils.getNoNil(getXMLBool(xmlFile, namei.."#static"), false);
		if isStatic then
			StaticParticleSystem.loadParticleSystem(xmlFile, self.threshingParticleSystems, namei, nodei, false, nil, self.baseDirectory);
		else
			Utils.loadParticleSystem(xmlFile, self.threshingParticleSystems, namei, nodei, false, nil, self.baseDirectory);
		end;
		Utils.setEmittingState(self.threshingParticleSystems,false);
		i = i +1;		
    end;

	self.speedmoto = 1.79;
	
	self.czas4 = 0;

end;

function heder_bs:delete()
   
end;

function heder_bs:mouseEvent(posX, posY, isDown, isUp, button)
end;

function heder_bs:keyEvent(unicode, sym, modifier, isDown)
if isDown and sym == Input.KEY_k then
		self.zapal = not self.zapal;
	end;
if isDown and sym == Input.KEY_f2 or isDown and sym == Input.KEY_f3 then
		self.zapall = not self.zapall;
	end;
end;


function heder_bs:update(dt)
--Animacje
    	if self:getIsActiveForSound() then
 	if InputBinding.isPressed(InputBinding.MOTOW) then
               self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.MOTON) then
               self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet+dt), false);
        end;
        	if InputBinding.isPressed(InputBinding.MOTOP) then
               self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[4].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.MOTOT) then
               self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet+dt), false);
        end;
end;


 if Input.isKeyPressed(Input.KEY_f2) then
    	if self.czas4 >= -1 then
		self.czas4 = self.czas4 +(dt/1);
    	end;
    else
    	if self.czas4 >= 2000 then
    		self.czas4 = 2100;
    	else
    		self.czas4 = 0;
    	end;
    end;

 if Input.isKeyPressed(Input.KEY_f3) then
    	if self.czas4 ~= 0 then
		self.czas4 = 0;
    end;
	else
		if self.czas4 == 0 then
		self.czas4 = 0;
    	end;
    end;

if self.zapal then
		for _, part in pairs(self.animacjapasy) do
          	setShaderParameter(part.node, "uvScrollSpeed", self.animationParts[2].clipSpeed/0.99*part.speed[1], self.animationParts[2].clipSpeed/0.99*part.speed[2], 0, 0, false);
      end;
	elseif not self.zapal then
		for _, part in pairs(self.animacjapasy) do
          	setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
	end;
     end;


	if self.zapal then  
      		self:setAnimationTime(1, 1);
		self:setAnimationTime(2, 1);
		self:setAnimationTime(5, 1);
     	 else 
     		 self:setAnimationTime(1, 0);
		 self:setAnimationTime(2, 0);
		self:setAnimationTime(5, 0);
      end;

	if self.czas4 >= 1300 then 
      		self.animationParts[1].clipSpeed = 1.6;
		self.animationParts[2].clipSpeed = self.speedmoto;
		self.animationParts[5].clipSpeed = 0.67;
	else 
 		self.animationParts[1].clipSpeed = 0.1;
		self.animationParts[5].clipSpeed = 0.1;
		self.animationParts[2].clipSpeed = 0.2;
      end;

	if self.animationParts[1].clipSpeed == 1.6 and self.zapal then
		self.reelStarted = true;
		else
		self.reelStarted = false;
	end;



      	if self:getIsActiveForInput() then 
    if InputBinding.isPressed(InputBinding.MOTOS) then
     if self.speedmoto < 1.8 then
      self.speedmoto = self.speedmoto+0.01;
	   end;
	  elseif InputBinding.isPressed(InputBinding.MOTOWO) then
	    if self.speedmoto > 0.6 then
      self.speedmoto = self.speedmoto-0.01;
      end;
	   end;
  end;
      	

end;

function heder_bs:draw()
end;

function heder_bs:onDetach()

end;

function heder_bs:onLeave()

end;

function heder_bs:onDeactivate()

end;